package cn.bunny.service.security;

import cn.bunny.common.constant.MessageConstant;
import cn.bunny.common.service.exception.BunnyException;
import cn.bunny.entity.system.SysRole;
import cn.bunny.entity.system.SysUser;
import cn.bunny.security.custom.CustomUser;
import cn.bunny.service.mapper.SysRoleMapper;
import cn.bunny.service.mapper.SysUserMapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Configuration;
import org.springframework.security.core.authority.AuthorityUtils;
import org.springframework.security.core.userdetails.UserDetails;
import org.springframework.security.core.userdetails.UsernameNotFoundException;

import java.util.List;

@Configuration
public class CustomUserDetailsService implements cn.bunny.security.service.CustomUserDetailsService {
    @Autowired
    private SysUserMapper sysUserMapper;
    @Autowired
    private SysRoleMapper sysRoleMapper;

    @Override
    public UserDetails loadUserByUsername(String username) throws UsernameNotFoundException {
        SysUser sysUser = sysUserMapper.selectOne(Wrappers.<SysUser>lambdaQuery().eq(SysUser::getUsername, username));
        List<SysRole> sysRoleList = sysRoleMapper.selectList(null);
        if (sysUser == null) {
            throw new UsernameNotFoundException(MessageConstant.USER_DOES_NOT_EXIST);
        }

        if (sysUser.getStatus() == 0) {
            throw new BunnyException(MessageConstant.ACCOUNT_LOCKED);
        }

        List<String> roleAuthoritieList = sysRoleList.stream().map(SysRole::getRoleCode).toList();
        return new CustomUser(sysUser, AuthorityUtils.createAuthorityList(roleAuthoritieList));
    }
}
