package cn.bunny.service.service;


import cn.bunny.entity.system.Login;
import cn.bunny.entity.system.SysUser;
import cn.bunny.entity.system.SysUserinfo;
import cn.bunny.vo.system.LoginVo;
import com.baomidou.mybatisplus.extension.service.IService;
import jakarta.servlet.http.HttpServletRequest;

/**
 * <p>
 * 用户表 服务类
 * </p>
 *
 * @author bunny
 * @since 2024-04-22
 */
public interface SysUserService extends IService<SysUser> {
    /**
     * 登录
     *
     * @param vo 登录条件
     * @return 返回token
     */
    Login login(LoginVo vo);

    /**
     * 获取用户信息
     *
     * @param request 请求头
     * @return 用户信息
     */
    SysUserinfo getUserinfo(HttpServletRequest request);

    /**
     * 根据用户名查询用户信息
     *
     * @param username 用户名
     * @return 用户信息
     */
    SysUser getByUsername(String username);
}
